#include <iostream>
#include <cstring>

using namespace std;

void nizcpy(int *, int *, int); // da izbjegnemo ponavljanje ovog koda
double arSr(int *, int);
int suma(int *, int);

class Test
{
private:
    int *niz;
    int duz;
    char *str;
public:
    static double maksAr;
    Test();
    Test(int *, int, char *);
    Test(const Test &);
    ~Test();
    void print();
    Test & operator=(const Test &);
    Test operator+(const Test &);
    Test & operator+=(const Test &);
    Test & operator++();
    Test operator++(int);
    int operator==(const Test &); // ne trazi se u zadatku, demonstracija
    friend void maksSuma(Test *, int);
};

double Test::maksAr = 0.0;

Test::Test()
{
    niz = 0;
    str = 0;
    duz = 0;
}

Test::Test(int *_niz, int _duz, char * _str) : duz(_duz)
{
    niz = new int[duz];
    nizcpy(niz, _niz, duz);
    str = new char[strlen(_str) + 1];
    strcpy(str, _str);
    double ar = arSr(niz, duz);
    if (ar > maksAr) maksAr = ar;
}

Test::Test(const Test &test) : duz(test.duz)
{
    niz = new int[duz];
    nizcpy(niz, test.niz, duz);
    str = new char[strlen(test.str) + 1];
    strcpy(str, test.str);
    double ar = arSr(niz, duz);
    if (ar > maksAr) maksAr = ar;
}

Test::~Test()
{
    delete[] niz;
    delete[] str;
    niz = 0;
    str = 0;
}

void Test::print()
{
    cout << "Niz je: ";
    for (int i = 0; i < duz; i++)
    {
        cout << niz[i] << " ";
    }
    cout << endl << "Dok je str: " << str << endl;
}

Test & Test::operator=(const Test &test)
{
    if (this != &test)
    {
        delete[] niz;
        delete[] str;
        duz = test.duz;
        niz = new int[duz];
        nizcpy(niz, test.niz, duz);
        str = new char[strlen(test.str) + 1];
        strcpy(str, test.str);
    }
    return *this;
}

Test Test::operator+(const Test &test) // revidirati!!
{
    int *noviNiz = new int[test.duz];
    nizcpy(noviNiz, test.niz, test.duz);
    char *noviStr = new char[strlen(str) + strlen(test.str) + 1];
    strcpy(noviStr, str);
    strcat(noviStr, test.str);
    Test noviTest(noviNiz, test.duz, noviStr);
    return noviTest;
}

Test & Test::operator+=(const Test &test)
{
    *this = *this + test;
    return *this;
}

Test & Test::operator++()
{
    niz[0] += 1;
    return *this;
}

Test Test::operator++(int i)
{
    Test temp(*this);
    niz[0] += 1;
    return temp;
}

int Test::operator==(const Test &test)
{
    if (duz != test.duz) return 0; // spojiti uslov za duzine
    for (int i = 0; i < duz; i++)
    {
        if (niz[i] != test.niz[i]) return 0;
    }
    if(strlen(str) != strlen(test.str)) return 0;
    int len = strlen(str); // iskoristiti funkciju koja poredi dva stringa
    for (int i = 0; i < len; i++)
    {
        if (str[i] != test.str[i]) return 0;
    }
    return 1;
}

void maksSuma(Test *x, int n)
{
    Test maks = x[0];
    for (int i = 1; i < n; i++)
    {
        if(suma(x[i].niz, x[i].duz) > suma(maks.niz, maks.duz))
            maks = x[i];
    }
    cout << "Rezultujuci str je: " << maks.str << endl;
}

void nizcpy(int *odr, int *izv, int duz)
{
    for (int i = 0; i < duz; i++)
    {
        odr[i] = izv[i];
    }
}

double arSr(int *x, int n)
{
    double sum = 0.0;
    for (int i = 0; i < n; i++)
    {
        sum += x[i];
    }
    return sum / n;
}

int suma(int *x, int n)
{
    int s = 0;
    for (int i = 0; i < n; i++) s+= x[i];
    return s;
}

int main()
{
    int niz1[] = {1, 3, 5, 7, 9};
    int niz2[] = {3, 4, 105};
    int niz3[] = {1005};
    Test t1(niz1, 5, "Prvi");
    Test t2(niz2, 3, "Drugi");
    Test t3(niz3, 1, "Treci");
    t1.print();
    Test t4 = t1 + t2;
    t4 += t3;
    t4++;
    ++t4;
    Test niz[3];
    niz[0] = t1;
    niz[1] = t2;
    niz[2] = t3;
    maksSuma(niz, 3);
    t4.print();
    cout << "maksAr je: " << Test::maksAr << endl;
    return 0;
}
